## ocaml-gnuplot 0.8.3

=== Makefile ===
# Ocaml-Gnuplot
# Copyright (C) Christophe TROESTLER

PKGNAME		= $(shell grep name META.in | \
			sed -e "s/.*\"\([^\"]*\)\".*/\1/")
PKGVERSION	= $(shell grep "@version" gnuplot.mli | \
			sed -r -e "s/[^0-9.]*([0-9.]+).*/\1/")

OCAMLOPT_EXISTS = $(shell which ocamlopt)

include Makefile.conf

OCAMLFLAGS 	= -dtypes
OCAMLOPTFLAGS	= -inline 2
OCAMLDOCFLAGS	= -stars -colorize-code
SED		= sed

# Order of the sources _must_ reflect order of dependency
GENERATED_SOURCES0 = gnuplot_sys.ml
GENERATED_SOURCES1 = gnuplot_ba_c.ml gnuplot_ba_f.ml gnuplot_array.ml
SOURCES = gnuplot_dir.ml $(GENERATED_SOURCES0) gnuplot_common_.ml \
  $(GENERATED_SOURCES1) gnuplot_bigarray.ml gnuplot_functor.ml gnuplot.ml
INTERFACES = gnuplot_common.mli gnuplot.mli

DISTFILES	= AUTHORS INSTALL LICENSE META.in Makefile Makefile.conf \
  $(filter-out $(GENERATED_SOURCES0),$(SOURCES)) $(INTERFACES) demos/ \
  gnuplot_arr_ba.ml gnuplot_macos.ml gnuplot_unix.ml gnuplot_win32.ml \
  make_array.ml gnuplot_dir.mli gnuplot_sys.mli

INSTALL_FILES = gnuplot_common.mli gnuplot.mli gnuplot_common.cmi gnuplot.cmi \
  gnuplot.cma
ifeq ($(OCAMLOPT_EXISTS),)
else
INSTALL_FILES += gnuplot.a gnuplot.cmx gnuplot.cmxa
endif

PKG_TARBALL 	= ocaml-$(PKGNAME)-$(PKGVERSION).tar.gz
ARCHIVE 	= $(shell grep "archive(byte)" META.in | \
			sed -e "s/.*\"\([^\"]*\)\".*/\1/")
XARCHIVE 	= $(shell grep "archive(native)" META.in | \
			sed -e "s/.*\"\([^\"]*\)\".*/\1/")

SRC_WEB 	= web
SF_WEB  	= /home/groups/o/oc/ocaml-gnuplot/htdocs/


default: all

.PHONY: all byte opt install install-byte install-opt doc dist
all: byte opt
byte: $(ARCHIVE)
opt: $(XARCHIVE)
doc: html

gnuplot.cma: $(INTERFACES:.mli=.cmi) $(SOURCES:.ml=.cmo)
	$(OCAMLC) $(OCAMLFLAGS) -a -o $@  $(SOURCES:.ml=.cmo)
gnuplot.cmxa: $(INTERFACES:.mli=.cmi) $(SOURCES:.ml=.cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@  $(SOURCES:.ml=.cmx)

# Generated files

gnuplot_array.ml: make_array.exe gnuplot_arr_ba.ml
	./$<
gnuplot_ba_%.ml: make_array.exe gnuplot_arr_ba.ml
	./$<

make_array.exe: make_array.ml
	$(OCAMLC) $(OCAMLFLAGS) -o $@ unix.cma str.cma $<

gnuplot_sys.ml: gnuplot_$(PLATFORM).ml
	$(COPY) $< $@

# Installation
.PHONY: install
install: META all
	$(OCAMLFIND) install $(PKGNAME) META $(INSTALL_FILES)

uninstall:
	$(OCAMLFIND) remove $(PKGNAME)

META: META.in
	$(COPY) $^ $@
	echo "version = \"$(PKGVERSION)\"" >> $@

# Packaging
.PHONY: tar
tar: $(PKG_TARBALL)

TARBALL_DIR=$(subst .tar.gz,,$(PKG_TARBALL))
$(PKG_TARBALL): $(DISTFILES)
	mkdir $(TARBALL_DIR)
	cp --preserve -r $(DISTFILES) $(TARBALL_DIR)/
	tar --exclude ".bzrignore" --exclude-from=.bzrignore \
	  -zcvf $(PKG_TARBALL) $(TARBALL_DIR)
	rm -rf $(TARBALL_DIR)

.PHONY: sync-svn
sync-svn:
	bzr push https://$$SF_USER@ocaml-gnuplot.svn.sourceforge.net/svnroot/ocaml-gnuplot/trunk/ocaml-gnuplot

# Documentation
html: $(PKGNAME).html/index.html

$(PKGNAME).html/index.html: $(INTERFACES) $(INTERFACES:.mli=.cmi)
	[ -d $(PKGNAME).html/ ] || mkdir $(PKGNAME).html
	$(OCAMLDOC) -d $(PKGNAME).html -html $(OCAMLDOCFLAGS) $(INTERFACES)
# 	cd $(PKGNAME).html; \
# 	for f in *; do \
# 		$(COPY) $$f $$f.bak; \
# 		$(SED) -e 's/$$VERSION/$(PKGVERSION)/' < $$f.bak > $$f; \
# 		rm -f $$f.bak; \
# 	done


# Examples

.PHONY: demos demos.opt webdemos
demos: byte
	cd demos/; $(MAKE)
demos.opt: opt
	cd demos/; $(MAKE) opt
webdemos: demos
	mkdir images/
	cd demos/; \
	for f in ex*.exe; do ./$$f -dev png; done; \
	mv *.png ../images/
#	Upload the demos to SF
	scp -r images/ shell.sf.net:$(SF_WEB)
	rm -rf images


# Release a Sourceforge tarball and publish the HTML doc 
.PHONY: web upload
web: doc
	@ if [ -d $(PKGNAME).html ] ; then \
	  scp -r $(PKGNAME).html shell.sf.net:$(SF_WEB)/ \
	  && echo "*** Published documentation on SF" ; \
	fi
	@ if [ -d $(SRC_WEB)/ ] ; then \
	  scp $(SRC_WEB)/*.html $(SRC_WEB)/*.jpg LICENSE \
	    shell.sf.net:$(SF_WEB) \
	  && echo "*** Published web site ($(SRC_WEB)/) on SF" ; \
	fi

upload: $(PKG_TARBALL)
	@ if [ -z "$(PKG_TARBALL)" ]; then \
		echo "PKG_TARBALL not defined"; exit 1; fi
	scp -C $(PKG_TARBALL) $$SF_USER@frs.sourceforge.net:uploads

# Caml general dependencies
.SUFFIXES: .ml .mli .cmi .cmo .cma .cmx .cmxa
%.cmi: %.mli
	$(OCAMLC) $(OCAMLFLAGS) -c $<
%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -c $<
%.cma: %.cmo
	$(OCAMLC) $(OCAMLFLAGS) -a -o $@  $^
%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c $<
%.cmxa: %.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@  $^

.PHONY: depend
depend: .depend
.depend: $(SOURCES) $(wildcard *.mli)
	$(OCAMLDEP) $^ > .depend

include .depend

########################################################################

.PHONY: clean dist-clean
clean:
	@ rm -f *~ .*~ *.{o,a} *.cm[aiox] *.cmxa *.annot
	@ rm -f $(GENERATED_SOURCES0) $(GENERATED_SOURCES1)
	@ rm -rf $(PKGNAME).html $(PKG_TARBALL)
	@ find . -type f -perm -u=x -exec rm -f {} \;
	@ if [ -d ./html ]; then rm -rf ./html; fi
	cd demos; $(MAKE) clean

dist-clean: clean
	rm -f .depend META

=== demos/Makefile ===
#	$Id: Makefile,v 1.8 2007-11-27 23:07:22 chris_77 Exp $	
# ocaml-gnuplot/demos
# Copyright (C) Christophe TROESTLER

include ../Makefile.conf

OCAMLFLAGS 	= -I ../
OCAMLOPTFLAGS	= -I ../
WEBDIR		= ../../webpublishing
WEBDIRDOC	= $(WEBDIR)/Gnuplot

DEMOS_LIBS 	= parse_args.ml
DEMOS 		= $(wildcard ex*.ml)

PKGS 	= $(shell grep "requires" ../META.in | \
		sed -e "s/.*\"\([^\"]*\)\".*/\1/")
PKGS 	+= gnuplot
PKGS_CMA = $(addsuffix .cma, $(PKGS))

.PHONY: demos byte opt

demos: byte
byte: $(DEMOS:.ml=.exe)
opt: $(DEMOS:.ml=.com)

ex%.exe: ex%.ml ../gnuplot.cma $(DEMOS_LIBS:.ml=.cmo)
	$(OCAMLC) -o $@ $(OCAMLFLAGS) $(PKGS_CMA) $(DEMOS_LIBS:.ml=.cmo) $<
ex%.com: ex%.ml ../gnuplot.cmxa $(DEMOS_LIBS:.ml=.cmx)
	$(OCAMLOPT) -o $@ $(OCAMLOPTFLAGS) $(PKGS_CMA:.cma=.cmxa) \
	  $(DEMOS_LIBS:.ml=.cmx) $<

parse_args.cmi: parse_args.mli ../gnuplot.cmi
parse_args.cmo: parse_args.ml parse_args.cmi ../gnuplot.cma
parse_args.cmx: parse_args.ml parse_args.cmi ../gnuplot.cmxa

# Caml general dependencies
.SUFFIXES: .ml .mli .cmo .cmi .cmx
%.cmi: %.mli
	$(OCAMLC) $(OCAMLFLAGS) -c $<
%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -c $<
%.cma: %.cmo
	$(OCAMLC) $(OCAMLFLAGS) -a -o $@  $^
%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c $<
%.cmxa: %.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@  $^

.PHONY: depend
depend: .depend
.depend: $(SOURCES) $(wildcard *.mli)
	$(OCAMLDEP) $^ > .depend

include .depend

########################################################################

.PHONY: clean dist-clean
clean:
	@ rm -f *~ .*~ *.{o,a} *.cm[aiox] *.cmxa *.annot *.exe *.com
	@ rm -f ex*-*.{png,plt,eps,ps,dat}

dist-clean: clean
	rm .depend

=== debian/changelog ===
ocaml-gnuplot (0.8.3-4) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Wed, 04 Sep 2019 14:17:56 +0200

ocaml-gnuplot (0.8.3-3) unstable; urgency=low

  * Patch install-byte: "make install" must depend only on the files that are
    to be installed. Fixes FTBFS on archs without native ocaml compilation.
    Thanks to Hendrik Tews for the hint (closes: #663172).
  * Standards-version 3.9.3
    - debian/copyright: refer to official 1.0 format

 -- Ralf Treinen <treinen@debian.org>  Sat, 10 Mar 2012 14:38:02 +0100

ocaml-gnuplot (0.8.3-2) unstable; urgency=low

  * Fix licence in debian/copyright (GPL -> LGPL)

 -- Ralf Treinen <treinen@debian.org>  Wed, 08 Feb 2012 08:32:53 +0100

ocaml-gnuplot (0.8.3-1) unstable; urgency=low

  * Initial release (closes: #494747)

 -- Ralf Treinen <treinen@debian.org>  Mon, 06 Feb 2012 18:38:28 +0100

=== debian/control ===
Source: ocaml-gnuplot
Section: ocaml
Priority: extra
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7.0.50~), dh-ocaml (>= 0.9~),
  ocaml-nox (>= 3.11.1-3~), ocaml-findlib
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-gnuplot.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-gnuplot
Homepage: http://sourceforge.net/projects/ocaml-gnuplot/

Package: libgnuplot-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml interface to the gnuplot utility
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports different output formats. This package
 provides an interface to Gnuplot from the Objective CAML programming
 language. All functions talk to gnuplot through a pipe, so crude animations
 are possible.

=== debian/rules ===
#!/usr/bin/make	 -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE)
else
	$(MAKE) byte
endif
	make doc

override_dh_auto_clean:
	# hack to avoid removal of debian/rules when building from git
	chmod 644 debian/rules
	make dist-clean
	chmod 755 debian/rules
